"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _FilePlugin = require("../../definitions/FilePlugin");

var _createFileModel = _interopRequireDefault(require("../utils/createFileModel"));

var _default = () => [new _FilePlugin.FilePlugin({
  beforeCreate: async ({
    data
  }) => {
    const FileModel = (0, _createFileModel.default)();
    const fileData = new FileModel().populate(data);
    await fileData.validate();
  },
  beforeUpdate: async ({
    data
  }) => {
    const FileModel = (0, _createFileModel.default)(false);
    const updatedFileData = new FileModel().populate(data);
    await updatedFileData.validate();
  },
  beforeBatchCreate: async ({
    data
  }) => {
    const FileModel = (0, _createFileModel.default)();

    for (const input of data) {
      const fileInstance = new FileModel().populate(input);
      await fileInstance.validate();
    }
  }
})];

exports.default = _default;