"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _apiSecurity = require("@webiny/api-security");

var _default = async (context, check = {}) => {
  await context.i18n.checkI18NContentPermission();
  const filePermission = await context.security.getPermission("fm.file");

  if (!filePermission) {
    throw new _apiSecurity.NotAuthorizedError();
  }

  if (check.rwd && !hasRwd(filePermission, check.rwd)) {
    throw new _apiSecurity.NotAuthorizedError();
  }

  return filePermission;
};

exports.default = _default;

const hasRwd = (filesFilePermission, rwd) => {
  if (typeof filesFilePermission.rwd !== "string") {
    return true;
  }

  return filesFilePermission.rwd.includes(rwd);
};