"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FilePlugin = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _plugins = require("@webiny/plugins");

class FilePlugin extends _plugins.Plugin {
  constructor(params) {
    super();
    (0, _defineProperty2.default)(this, "_params", void 0);
    this._params = params || {};
  }

  async beforeCreate(params) {
    await this._execute("beforeCreate", params);
  }

  async afterCreate(params) {
    await this._execute("afterCreate", params);
  }

  async beforeUpdate(params) {
    await this._execute("beforeUpdate", params);
  }

  async afterUpdate(params) {
    await this._execute("afterUpdate", params);
  }

  async beforeBatchCreate(params) {
    await this._execute("beforeBatchCreate", params);
  }

  async afterBatchCreate(params) {
    await this._execute("afterBatchCreate", params);
  }

  async beforeDelete(params) {
    await this._execute("beforeDelete", params);
  }

  async afterDelete(params) {
    await this._execute("afterDelete", params);
  }
  /**
   * Keep any here because it can be a number of params. Method is internal so no need to complicate the code.
   */


  async _execute(callback, params) {
    const cb = this._params[callback];

    if (typeof cb !== "function") {
      return;
    }

    await cb(params);
  }

}

exports.FilePlugin = FilePlugin;
(0, _defineProperty2.default)(FilePlugin, "type", "fm.file");