import { FileManagerContext } from "../../types";
import { Plugin } from "@webiny/plugins";
export interface InstallationPluginParams {
    context: FileManagerContext;
}
export declare type CallbackFunction<TParams> = (params: TParams) => Promise<void>;
interface InstallationPluginConfig {
    beforeInstall?: CallbackFunction<InstallationPluginParams>;
    afterInstall?: CallbackFunction<InstallationPluginParams>;
}
export declare abstract class InstallationPlugin extends Plugin {
    static readonly type: string;
    private readonly _config;
    constructor(config?: Partial<InstallationPluginConfig>);
    beforeInstall(params: InstallationPluginParams): Promise<void>;
    afterInstall(params: InstallationPluginParams): Promise<void>;
    private _execute;
}
export {};
