"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _api = require("@webiny/api");

var _FileStorage = require("./FileStorage");

const fileStorageContextPlugin = new _api.ContextPlugin(async context => {
  if (!context.fileManager) {
    /**
     * We need to define the fileManager initial property as empty object.
     * When casting as FileManagerContext, typescript is complaining.
     */
    context.fileManager = {};
  }

  context.fileManager.storage = new _FileStorage.FileStorage({
    context
  });
});
var _default = fileStorageContextPlugin;
exports.default = _default;